set term postscript eps 

set style line 11 lt 1 lw 0.8 ps 0.8 pt 6 lc rgb "#CC3300" # red
set style line 12 lt 2 lw 0.8 ps 0.8 pt 6 lc rgb "#CC3300" # red
set style line 21 lt 1 lw 0.8 ps 0.8 pt 2 lc rgb "#009900" # green
set style line 22 lt 2 lw 0.8 ps 0.8 pt 2 lc rgb "#009900" # green
set style line 31 lt 1 lw 0.8 ps 0.8 pt 8 lc rgb "#CC9900" # orange
set style line 32 lt 2 lw 0.8 ps 0.8 pt 8 lc rgb "#CC9900" # orange
set style line 41 lt 1 lw 0.8 ps 0.8 pt 1 lc rgb "#3366CC" # blue
set style line 42 lt 2 lw 0.8 ps 0.8 pt 1 lc rgb "#3366CC" # blue
set style line 51 lt 1 lw 0.8 ps 0.8 pt 2 lc rgb "#00CCFF" # sky
set style line 52 lt 2 lw 0.8 ps 0.8 pt 2 lc rgb "#00CCFF" # sky
set style line 61 lt 1 lw 0.8 ps 0.8 pt 2 lc rgb "#000000" # black
set style line 62 lt 2 lw 0.8 ps 0.8 pt 2 lc rgb "#000000" # black
set style line 71 lt 1 lw 0.8 ps 0.8 pt 14 lc rgb "#66CCFF" # 
set style line 81 lt 1 lw 0.8 ps 0.8 pt 11 lc rgb "#33CC99" #

set style line 91 lt 1 lw 0.8 ps 0.8 pt 6 lc rgb "#FF6600" # orange
set style line 92 lt 1 lw 0.8 ps 0.8 pt 2 lc rgb "#66CC00" # green
set style line 93 lt 1 lw 0.8 ps 0.8 pt 8 lc rgb "#3399FF" # blue
set style line 94 lt 1 lw 0.8 ps 0.8 pt 1 lc rgb "#9933FF" # purple

##################################################################################################################
# Settings
##################################################################################################################

set key right bottom
set xlabel "Matrix Size (M=N)"
set ylabel "GB/s" offset 2,0
set grid
set size 0.55,0.55
set lmargin 7
set rmargin 3
set tmargin 3
set bmargin 3
#set xrange [0:4000]
#set yrange [100:]
set yrange [0:]

##################################################################################################################
# plot
##################################################################################################################

### GEMV ###
set title "MUBLAS 1.3.1 GEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_mublas_gemv_n_gtx580.eps"
plot \
"testing_mublas_sgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 SGEMV-N" w linespoints ls 11,\
"testing_mublas_dgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 DGEMV-N" w linespoints ls 21,\
"testing_mublas_cgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 CGEMV-N" w linespoints ls 31,\
"testing_mublas_zgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 ZGEMV-N" w linespoints ls 41
set title "SGEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_sgemv_n_gtx580.eps"
plot \
"testing_mublas_sgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 SGEMV-N" w linespoints ls 11,\
"testing_cublas_sgemv_n_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 SGEMV-N" w linespoints ls 21,\
"testing_kblas_sgemv_n_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta SGEMV-N" w linespoints ls 31,\
"testing_magma_sgemv_n_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 SGEMV-N" w linespoints ls 41
set xtics (4000,8000,12000,16000,20000)
set title "DGEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange[0:18432]
set output "fig_testing_dgemv_n_gtx580.eps"
plot \
"testing_mublas_dgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 DGEMV-N" w linespoints ls 11,\
"testing_cublas_dgemv_n_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 DGEMV-N" w linespoints ls 21,\
"testing_kblas_dgemv_n_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta DGEMV-N" w linespoints ls 31,\
"testing_magma_dgemv_n_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 DGEMV-N" w linespoints ls 41
set title "CGEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange[0:18432]
set output "fig_testing_cgemv_n_gtx580.eps"
plot \
"testing_mublas_cgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 CGEMV-N" w linespoints ls 11,\
"testing_cublas_cgemv_n_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 CGEMV-N" w linespoints ls 21,\
"testing_kblas_cgemv_n_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta CGEMV-N" w linespoints ls 31,\
"testing_magma_cgemv_n_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 CGEMV-N" w linespoints ls 41
set xtics auto
set title "ZGEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange[0:12928]
set output "fig_testing_zgemv_n_gtx580.eps"
plot \
"testing_mublas_zgemv_n_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 ZGEMV-N" w linespoints ls 11,\
"testing_cublas_zgemv_n_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 ZGEMV-N" w linespoints ls 21,\
"testing_kblas_zgemv_n_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta ZGEMV-N" w linespoints ls 31,\
"testing_magma_zgemv_n_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 ZGEMV-N" w linespoints ls 41

### GEMV-T ###
set title "MUBLAS 1.3.1 GEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_mublas_gemv_t_gtx580.eps"
plot \
"testing_mublas_sgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 SGEMV-T" w linespoints ls 11,\
"testing_mublas_dgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 DGEMV-T" w linespoints ls 21,\
"testing_mublas_cgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 CGEMV-T" w linespoints ls 31,\
"testing_mublas_zgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 ZGEMV-T" w linespoints ls 41
set title "SGEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_sgemv_t_gtx580.eps"
plot \
"testing_mublas_sgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 SGEMV-T" w linespoints ls 11,\
"testing_cublas_sgemv_t_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 SGEMV-T" w linespoints ls 21,\
"testing_kblas_sgemv_t_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta SGEMV-T" w linespoints ls 31,\
"testing_magma_sgemv_t_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 SGEMV-T" w linespoints ls 41
set title "DGEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange[0:18432]
set output "fig_testing_dgemv_t_gtx580.eps"
plot \
"testing_mublas_dgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 DGEMV-T" w linespoints ls 11,\
"testing_cublas_dgemv_t_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 DGEMV-T" w linespoints ls 21,\
"testing_kblas_dgemv_t_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta DGEMV-T" w linespoints ls 31,\
"testing_magma_dgemv_t_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 DGEMV-T" w linespoints ls 41
set title "CGEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange[0:18432]
set output "fig_testing_cgemv_t_gtx580.eps"
plot \
"testing_mublas_cgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 CGEMV-T" w linespoints ls 11,\
"testing_cublas_cgemv_t_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 CGEMV-T" w linespoints ls 21,\
"testing_kblas_cgemv_t_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta CGEMV-T" w linespoints ls 31,\
"testing_magma_cgemv_t_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 CGEMV-T" w linespoints ls 41
set title "ZGEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange[0:12928]
set output "fig_testing_zgemv_t_gtx580.eps"
plot \
"testing_mublas_zgemv_t_gtx580.dat" using 1:5 every 1 title "MUBLAS 1.3.1 ZGEMV-T" w linespoints ls 11,\
"testing_cublas_zgemv_t_gtx580.dat" using 1:5 every 1 title "CUBLAS 7.0 ZGEMV-T" w linespoints ls 21,\
"testing_kblas_zgemv_t_gtx580.dat" using 1:5 every 1 title "KBLAS 1.3-beta ZGEMV-T" w linespoints ls 31,\
"testing_magma_zgemv_t_gtx580.dat" using 1:5 every 1 title "MAGMA 1.6.1 ZGEMV-T" w linespoints ls 41

### check ###
set format y "%1.1e" 
set yrange [1e-17:]
set logscale y
set ylabel "error" offset 2,0

set title "MUBLAS 1.3.1 GEMV-N (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_mublas_gemv_n_gtx580_check.eps"
plot \
"testing_mublas_sgemv_n_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 SGEMV-N" w linespoints ls 11,\
"testing_mublas_dgemv_n_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 DGEMV-N" w linespoints ls 21,\
"testing_mublas_cgemv_n_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 CGEMV-N" w linespoints ls 31,\
"testing_mublas_zgemv_n_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 ZGEMV-N" w linespoints ls 41

set title "MUBLAS 1.3.1 GEMV-T (GeForce GTX 580, CUDA 7.0)"
set xrange [0:25856]
set output "fig_testing_mublas_gemv_t_gtx580_check.eps"
plot \
"testing_mublas_sgemv_t_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 SGEMV-T" w linespoints ls 11,\
"testing_mublas_dgemv_t_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 DGEMV-T" w linespoints ls 21,\
"testing_mublas_cgemv_t_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 CGEMV-T" w linespoints ls 31,\
"testing_mublas_zgemv_t_gtx580_check.dat" using 1:3 every 1 title "MUBLAS 1.3.1 ZGEMV-T" w linespoints ls 41

