#ifndef PREC_D_H
#define PREC_D_H

#ifdef PREC_D


#define FPADDCOUNT 1
#define FPMULCOUNT 1
#define FPMADCOUNT 2

// TYPE
#define CBLAS_TYPE double
#define CBLAS_BASETYPE CBLAS_TYPE
#define MBLAS_TYPE qd_real
#define MBLAS_BASETYPE MBLAS_TYPE
#define CBLAS_ZERO 0.
#define CBLAS_ONE 1.
#define CBLAS_NEGONE -1.
#define MBLAS_ZERO qd_real(0.)
#define MBLAS_ONE qd_real(1.)
#define MBLAS_NEGONE qd_real(-1.)

#if defined (MUBLAS)
#define GPU_TYPE double
#elif defined (CUBLAS)
#define GPU_TYPE double
#elif defined (KBLAS)
#define GPU_TYPE double
#elif defined (MAGMA)
#define GPU_TYPE double
#elif defined (CULA)
#define GPU_TYPE double
#elif defined (ASPEN)
#define GPU_TYPE double
#endif
#define MAKE_GPU_TYPE(x) (x)

// COPY
#define CBLAS_COPY cblas_dcopy
#define MBLAS_COPY Rcopy
#define MUBLAS_COPY mublasDcopy
#define CUBLAS_COPY cublasDcopy
#define MAGMA_COPY magmablas_dcopy
#define CULA_COPY culaDeviceDcopy
#define KBLAS_COPY kblas_dcopy

// SCAL
#define CBLAS_SCAL cblas_dscal
#define MBLAS_SCAL Rscal
#define MUBLAS_SCAL mublasDscal
#define CUBLAS_SCAL cublasDscal
#define MAGMA_SCAL 
#define CULA_SCAL 
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_daxpy
#define MBLAS_AXPY Raxpy
#define MUBLAS_AXPY mublasDaxpy
#define CUBLAS_AXPY cublasDaxpy
#define MAGMA_AXPY magmablas_daxpy
#define CULA_AXPY culaDeviceDaxpy
#define KBLAS_AXPY kblas_daxpy

// DOT
#define CBLAS_DOT cblas_ddot
#define MBLAS_DOT Rdot
#define MUBLAS_DOT mublasDdot
#define CUBLAS_DOT cublasDdot
#define MAGMA_DOT magmablas_ddot
#define CULA_DOT culaDeviceDdot
#define KBLAS_DOT kblas_ddot

// GEMV
#define CBLAS_GEMV cblas_dgemv
#define MBLAS_GEMV Rgemv
#define MUBLAS_GEMV mublasDgemv
#define CUBLAS_GEMV cublasDgemv
#define MAGMA_GEMV magmablas_dgemv
#define CULA_GEMV culaDeviceDgemv
#define KBLAS_GEMV kblas_dgemv
#define ASPEN_GEMV ASPEN_dgemv

// SYMV
#define CBLAS_SYMV cblas_dsymv
#define MBLAS_SYMV Rsymv
#define MUBLAS_SYMV
#define CUBLAS_SYMV cublasDsymv
#define MAGMA_SYMV magmablas_dsymv
#define CULA_SYMV culaDeviceDsymv
#define KBLAS_SYMV kblas_dsymv
#define ASPEN_SYMV ASPEN_dsymv

// TRMV
#define CBLAS_TRMV cblas_dtrmv
#define MBLAS_TRMV Rtrmv
#define MUBLAS_TRMV mublasDtrmv
#define CUBLAS_TRMV cublasDtrmv
#define MAGMA_TRMV magmablas_dtrmv
#define CULA_TRMV culaDeviceDtrmv
#define KBLAS_TRMV
#define ASPEN_TRMV

// TRSV
#define CBLAS_TRSV cblas_dtrsv
#define MBLAS_TRSV Rtrsv
#define MUBLAS_TRSV mublasDtrsv
#define CUBLAS_TRSV cublasDtrsv
#define MAGMA_TRSV magmablas_dtrsv
#define CULA_TRSV culaDeviceDtrsv
#define KBLAS_TRSV
#define ASPEN_TRSV

// GEMM
#define CBLAS_GEMM cblas_dgemm
#define MBLAS_GEMM Rgemm
#define MUBLAS_GEMM mublasDgemm
#define CUBLAS_GEMM cublasDgemm
#define MAGMA_GEMM magmablas_dgemm
#define CULA_GEMM culaDeviceDgemm
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_dnrm2
#define MBLAS_NRM Rnrm2

// GER
#define CBLAS_GER cblas_dger
#define MBLAS_GER Rger
#define MUBLAS_GER 
#define CUBLAS_GER cublasDger
#define MAGMA_GER magmablas_dger
#define CULA_GER culaDeviceDger
#define KBLAS_GER 
#define ASPEN_GER 

#endif

#endif
